From a5266a996789738794601259a99052282b76e8b9 Mon Sep 17 00:00:00 2001
From: Andrew Price <andrewprice@andrewalexanderprice.com>
Date: Mon, 5 Sep 2011 01:48:38 +0930
Subject: [PATCH 7/8] doubled the framerate - thanks fenrir!

---
 modules/video_filter/stereoscopy.c |   16 ++++++++--------
 src/misc/picture.c                 |   19 ++++++++++++-------
 src/video_output/video_output.c    |    3 ++-
 3 files changed, 22 insertions(+), 16 deletions(-)

diff --git a/modules/video_filter/stereoscopy.c b/modules/video_filter/stereoscopy.c
index 424a305..56a8645 100644
--- a/modules/video_filter/stereoscopy.c
+++ b/modules/video_filter/stereoscopy.c
@@ -907,7 +907,7 @@ static picture_t *Filter( filter_t *p_filter, picture_t *p_inpic )
 
     /* CORRECT METHOD BUT COMMENTED OUT WHILE 'DROPPING PICTURES' ISSUE REMAINS */
 
-	/* calculate time difference and find mid point (to insert other frame at) *//*
+	/* calculate time difference and find mid point (to insert other frame at) */
 	mtime_t i_currentTime = p_inpic->date;
 	mtime_t i_midPoint = p_sys->i_lastTime + (i_currentTime - p_sys->i_lastTime) / 2;
 	p_sys->i_lastTime = i_currentTime;
@@ -940,16 +940,16 @@ static picture_t *Filter( filter_t *p_filter, picture_t *p_inpic )
 
     picture_Release(p_inpic);
     return p_leftOut;
-    */
+    
 
     /* DECODES LEFT AND RIGHT FRAMES ALTERNATIVELY, DROPS A FRAME BUT IS A
        WORKAROUND UNTIL DROPPING PICTURES IS FIXED */
-	
+	/*
     if(p_sys->b_leftEyeLast)
     {
         p_sys->b_leftEyeLast = false;
-
-        /* do right eye */
+		*/
+        /* do right eye *//*
         picture_t *p_rightOut = DecodeImageYUV( p_filter, p_inpic,
             p_sys->i_rightEyeMethod, chromaformat);
 
@@ -967,8 +967,8 @@ static picture_t *Filter( filter_t *p_filter, picture_t *p_inpic )
     else
     {
         p_sys->b_leftEyeLast = true;
-
-        /* do left eye */
+		*/
+        /* do left eye *//*
         picture_t *p_leftOut = DecodeImageYUV( p_filter, p_inpic,
             p_sys->i_leftEyeMethod, chromaformat);
 
@@ -982,7 +982,7 @@ static picture_t *Filter( filter_t *p_filter, picture_t *p_inpic )
         p_leftOut->i_eye = 1;
         picture_Release( p_inpic );
         return p_leftOut;
-    }
+    }*/
 }
 
 /*****************************************************************************
diff --git a/src/misc/picture.c b/src/misc/picture.c
index b63f843..5f9bb31 100644
--- a/src/misc/picture.c
+++ b/src/misc/picture.c
@@ -263,13 +263,18 @@ picture_t *picture_New( vlc_fourcc_t i_chroma, int i_width, int i_height, int i_
  *****************************************************************************/
 void picture_Delete( picture_t *p_picture )
 {
-    assert( p_picture && p_picture->i_refcount == 0 );
-    assert( p_picture->p_release_sys == NULL );
-
-    free( p_picture->p_q );
-    free( p_picture->p_data_orig );
-    free( p_picture->p_sys );
-    free( p_picture );
+        /* while( p_picture != NULL ) { */
+        picture_t *p_next = p_picture->p_next;
+
+        assert( p_picture && p_picture->i_refcount == 0 );
+        assert( p_picture->p_release_sys == NULL );
+
+        free( p_picture->p_q );
+        free( p_picture->p_data_orig );
+        free( p_picture->p_sys );
+	    free( p_picture );
+		p_picture = p_next;
+        /*}*/
 }
 
 /*****************************************************************************
diff --git a/src/video_output/video_output.c b/src/video_output/video_output.c
index 48aad90..a942a96 100644
--- a/src/video_output/video_output.c
+++ b/src/video_output/video_output.c
@@ -746,7 +746,8 @@ static void ThreadChangeFilters(vout_thread_t *vout,
             e->name = name;
             e->cfg  = cfg;
             if (!strcmp(e->name, "deinterlace") ||
-                !strcmp(e->name, "postproc")) {
+                !strcmp(e->name, "postproc") ||
+                !strcmp(e->name, "stereoscopy")) {
                 vlc_array_append(&array_static, e);
             } else {
                 vlc_array_append(&array_interactive, e);
-- 
1.7.4.msysgit.0

